// ***********************************************************************
//			Input Capture Lab1
// Purpose : mߦpϥ Capture ҲտJpXJHgPWv
//           ñNgPWvHj 200mS ܩ LCD W
//
// ***********************************************************************

//#define __dsPIC30F4011__

#include 	<p30F4011.h>
#include 	"C30EVM_LCD.h"			// N禡쫬ŧiɮקtJ 
#include	<timer.h>
#include	<incap.h>

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="Freq. =      Hz " ;	// ŧir Program Memory
const  char	My_String2[]="Period=      uS " ;	 

void update_LCD(void);
void uitoa( unsigned char * , unsigned int );
void Init_Capture7(void);
void Init_Timer1(void);

int  Int_flag;
unsigned int timer_edge[2];
unsigned char	Convert_Buf[10] ;
unsigned int period;
unsigned int frequency;

void __attribute__((interrupt, no_auto_psv)) _IC7Interrupt(void)		// J_Ƶ{
{	
	ReadCapture7( &timer_edge[0]);
	ReadCapture7( &timer_edge[1]);
	Int_flag = 1;					// ]wn餤_X
	IFS1bits.IC7IF = 0;				// MJ_X
}

int main(void)
{


	ADPCFG = 0xffff;					// Set All Analog Pins as Digital IO

	OpenLCD( ) ;						// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
										// 4 bits Data mode, 5 * 7 Character 

	setcurLCD(0,0) ;					// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String1 ) ;			// Nsb Program Memory rϦLX LCD
			
	setcurLCD(0,1) ;
	putrsLCD( My_String2 ) ;			// ϥ setcurLCD( ) ]wЩ (0,1)
															
	Int_flag = 0;

	Init_Timer1( );
	Init_Capture7( );


	while(1)
	{
		while(!Int_flag); 				// Get two input signal edge
		DisableIntIC7;					// Disable Interrupt of Capture 7
		Int_flag = 0;

		if( timer_edge[1] >= timer_edge[0]) 	// calculate time count between two capture events 
			period = timer_edge[1] - timer_edge[0];

		else
			period = 65536 + timer_edge[1] - timer_edge[0];

		frequency= FCY/period;			// Calculate the frequency
		period = period / 14.745600 ;	// Calculate the period

		if (IFS0bits.T1IF)				// over 200mS ? 
		{	
			IFS0bits.T1IF=0;
			update_LCD( );				// yes, update frequency & Period to LCD
		}
		
//		OC1CON |= 0x0006 ;				// OR with 0bxxxx xxxx xxxx x110
		IFS1bits.IC7IF = 0;
		ReadCapture7(timer_edge);
		EnableIntIC7;					// Enable Interrupt of Capture 7
	}
	CloseCapture7();
}

void update_LCD(void)
{
		uitoa ( Convert_Buf , frequency ) ;
		setcurLCD(8,0) ;
		putrsLCD( "     " ) ;
		setcurLCD(8,0) ;
		putsLCD( Convert_Buf ) ;

		uitoa ( Convert_Buf , period ) ;
		setcurLCD(8,1) ;
		putrsLCD( "    " ) ;
		setcurLCD(8,1) ;
		putsLCD( Convert_Buf ) ;
}

void	uitoa( unsigned char *ASCII_Buf , unsigned int IntegerValue )
{
	
	unsigned int TempValue ;
	unsigned char ZeroDisable ;
	unsigned int  BaseQty ;
	unsigned int  Loop ;

	ZeroDisable = 1 ;
	BaseQty = 10000 ;

	for ( Loop = 0 ; Loop < 4 ; Loop ++)
	{
		TempValue = IntegerValue / BaseQty ;

			if 	( TempValue > 0) 	
				{
					*ASCII_Buf++ = (unsigned char)TempValue + '0' ;
					ZeroDisable = 0 ;
				}
			else if	( ZeroDisable == 0 ) 
					*ASCII_Buf++ = '0' ;
		IntegerValue = IntegerValue - ( TempValue * BaseQty ) ;
		BaseQty = BaseQty / 10 ;

	}
		*ASCII_Buf++ = (unsigned char)IntegerValue + '0' ;
		*ASCII_Buf = (unsigned char) 0x00 ;
		
}
//**************************************************
// Configure the InputCapture in stop in idle mode 
// Timer 3 as source , interrupt on capture 7, 
// I/C on every fall edge 
//**************************************************
void Init_Capture7(void)
{
	OpenCapture7(IC_IDLE_STOP & IC_TIMER3_SRC &
	             IC_INT_2CAPTURE & IC_EVERY_FALL_EDGE);
	ConfigIntCapture7(IC_INT_PRIOR_7 & IC_INT_ON);

	T3CON = 0x8000; 					// Timer 3 On
}
/*************************************************/
// Timer1 ҲժlưƵ{
// 100mS Interrupt setting
/*************************************************/
void Init_Timer1(void)
{
		ConfigIntTimer1( T1_INT_PRIOR_0 & T1_INT_OFF ) ;	//  Timer1 _
														 

		OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 	// Timer1  Period ]C 200 ms 
					T1_PS_1_64 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
					(long)((FCY/ 1000)* 200 )/64 ) ;
}

