// ***********************************************************************
// File : 		I2CSIM_Main.C

// ***********************************************************************

#include 	<p30F4011.h>
#include 	"C30EVM_LCD.h"			// NLCD禡쫬ŧiɮקtJ 
#include	<timer.h>				// NTimer禡쫬ŧiɮקtJ
#include	<adc10.h>				// Nadc10禡쫬ŧiɮקtJ
#include	"ADCSubs.h"
#include	"I2CSubs.h"

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="VR1:    VR2:    " ;	// ŧir Program Memory (] const ŧi)
	  char	My_String2[]="EE1:    EE2:    " ;	// ŧir Data Memory

unsigned int miliSec ;

void	Init_ADC(void) ;
void	Show_ADC(void) ;

// union ŧiN8줸ܼByteAccessPSystemFlagcܼƨϥάۦPOA
// HQP榡줸BݨD
union 	{
			unsigned char ByteAccess ;
			struct 	{
						unsigned Bit0: 1 ;
						unsigned Bit1: 1 ;
						unsigned Bit2: 1 ;
						unsigned unused : 5 ;
					} ;
		} SystemFlag ;

//wqOneSecondXеPSystemFlag.Bit0줸ܼơAGNϥΤ@Ӧ줸OЪŶ
#define	OneSecond	SystemFlag.Bit0 	

void _ISR _T1Interrupt(void)		//Timer1_Ƶ{
{

	miliSec += 1 ;

	if (miliSec == 1000)			//C1000NOneSecondXг]w1
		{
			OneSecond = 1 ;
			miliSec  = 0 ;
		} 
	IFS0bits.T1IF = 0 ;				//M_X

}


	unsigned int 	ADC_Value;
	unsigned char 	EEPROM_Data1 , EEPROM_Data2 ;
	int				WaitLoop ;

int	main( void )
{


	Init_ADC( ) ;										// NADCilƳ]w
	Init_I2C( ) ;

	OpenLCD( ) ;										// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
														// 4 bits Data mode
														// 5 * 7 Character 

	setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String1 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
	setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
	putrsLCD( My_String2 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD

	ConfigIntTimer1( T1_INT_PRIOR_7 & T1_INT_ON ) ;		// Timer1 _uų] 7 (̰)
														// Timer1 _ ON 

	OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 			// Timer1  Period ]C 1ms 
				T1_PS_1_1 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
				(FCY/ 1000) ) ;

	OneSecond = 0 ;

	while(1) 
	{	
		if ( OneSecond ) 								// ߰ Timer1  Period ɶO_w
														// iHγnˬdO_ǽT 1 ms
		{
			OneSecond = 0 ;		

				WaitLoop = 0 ;
				do
				{
					if ( !I2C_ACKPolling(0xA0 )) 		// Return value : 0= ACK  , 1 = NACK
						{		
							EEPROM_Data1 = EEPROM_ByteRead( 0xA0  , 0x10  ) ;
							EEPROM_Data2 = EEPROM_ByteRead( 0xA0 , 0x20 ) ;	
							WaitLoop = 1000 ;
						}
					else
							WaitLoop ++ ;

				}while (WaitLoop < 1000) ;					 
					
			ADC_Value = Get_VR1( ) ;								
			setcurLCD(4,0) ;							// Set LCD cursor		
			put_Num_LCD( ADC_Value >> 2 ) ;				// NഫGHQiƦrܦܲGܾ

				WaitLoop = 0 ;
				do
				{
					if ( !I2C_ACKPolling(0xA0 )) 		// Return value : 0= ACK  , 1 = NACK
						{		
							EEPROM_ByteWrite( 0xA0 , 0x10 , ADC_Value >> 2 ) ;
							WaitLoop = 1000 ;
						}
					else
							WaitLoop ++ ;
				}while (WaitLoop < 1000) ;

			ADC_Value = Get_VR2( ) ;								
			setcurLCD(12,0) ;							// Set LCD cursor		
			put_Num_LCD( ADC_Value >> 2 ) ;				// NഫGHQiƦrܦܲGܾ	

					WaitLoop = 0 ;
				do
				{
					if ( !I2C_ACKPolling(0xA0 )) 		// Return value : 0= ACK  , 1 = NACK
						{		
							EEPROM_ByteWrite( 0xA0 , 0x20 , ADC_Value >> 2 ) ;
							WaitLoop = 1000 ;
						}
					else
							WaitLoop ++ ;
				}while (WaitLoop < 1000) ;

					


			setcurLCD(4,1) ;							// Set LCD cursor		
			put_Num_LCD( EEPROM_Data1 ) ;				// NഫGHQiƦrܦܲGܾ
			setcurLCD(12,1) ;							// Set LCD cursor		
			put_Num_LCD( EEPROM_Data2 ) ;				// NഫGHQiƦrܦܲGܾ

		}
	}		
}


