// ***********************************************************************
// Purpose : 	ϥ TIMER 3 @ ADC ഫĲoӷ
//				TIMER 3 uݳW Period Yi , ݭP䤤_
// ***********************************************************************
#include 	<p30fxxxx.h>
#include 	<timer.h>
#include	"C30EVM_LCD.h"

#define		LED1		LATEbits.LATE0 
#define		CTRL_LED1	TRISEbits.TRISE0 

#define		FCY	7372800 * 2
 
void		Timer3_Initial( void ) ;
void		ADC10_Initial( void ) ;
void		uitoa( unsigned char *, unsigned int ) ;


union
	{
	unsigned Word ; 
	struct		
		{	
			unsigned ADC_DONE : 1 ;
			unsigned : 15 ;
		};
	} Flags ;

unsigned int	ADC_Buf ;
unsigned int	MyADC ;
unsigned char	ASCII_Buf[10] ;

//---------------------------------------------------------------------------
// Configuration bits

   _FOSC(CSW_FSCM_OFF & XT_PLL8);   //XT with 4xPLL oscillator, Failsafe clock off
   _FWDT(WDT_OFF);                  //Watchdog timer disabled
   _FBORPOR(PBOR_OFF & MCLR_EN);    //Brown-out reset disabled, MCLR reset enabled
   _FGS(CODE_PROT_OFF);             //Code protect disabled

  

void _ISR _ADCInterrupt(void)
{

		Flags.ADC_DONE = 1 ;
		IFS0bits.ADIF = 0 ;
		MyADC = ADCBUF0 ;
		LED1 = !LED1 ;

}

int	main( void )

{
		Timer3_Initial( ) ;
		ADC10_Initial( ) ;
		OpenLCD( ) ;

		CTRL_LED1 = 0 ;

		Flags.Word = 0 ;
		  putrsLCD("Lab1:ADC Trigger ") ;
		    setcurLCD(0,1) ;
		      putrsLCD("TR3 Trig AD=    ") ;

 while (1) 
	{
		while ( Flags.ADC_DONE == 0 ) ;

			Flags.ADC_DONE = 0 ;
			setcurLCD(12,1) ;
			putrsLCD("    ") ;
			setcurLCD(12,1) ;
			uitoa( ASCII_Buf , MyADC );
			putsLCD(ASCII_Buf) ;
	}
}



void	Timer3_Initial( void )
{
		ConfigIntTimer3( T3_INT_PRIOR_7 & T3_INT_OFF ) ; // Disable Timer 3 Interrupt

		OpenTimer3( T3_ON & T3_IDLE_STOP & T3_GATE_OFF & T3_PS_1_64 & T3_SOURCE_INT ,
				    (((long)FCY/1000 )) ) ;   // Set for 64 mS
}

void ADC10_Initial(void)
{

 	ADPCFG = 0xFFBF;				// AN6/RB6 is Analog , others are Digital;
 	ADCON1 = 0x0046;				// 0b0000 0000 0100 0110 
									// Auto convert using TMR3 as trigger source
									// A/D Sample Auto-Start
 	ADCON2 = 0x0000;				// ADCON2 = 0000 0000 0000 0000
									// Don't scan inputs , SMPi = 00 ( Interrupt for each sample/convert )
 	ADCSSL = 0x0000;				// no scan input selected .......
 	ADCON3 = 0x1F3F;				// TAD = 8 Tcy , SAMC = 15 TAD 
	ADCHS =  0x06 ;					// ADCHS = 0b 00000000 00000110

	IEC0bits.ADIE = 1 ;				// Enable AD interrupt
	IPC2bits.ADIP = 7 ;				// Set Priority to 7 	>> highest !!
 
 	ADCON1bits.ADON = 1;			// turn ADC ON
}

void	uitoa( unsigned char *ASCII_Buf , unsigned int IntegerValue )
{
	
	unsigned int TempValue ;
	unsigned char ZeroDisable ;
	unsigned int  BaseQty ;
	unsigned int  Loop ;

	ZeroDisable = 1 ;
	BaseQty = 10000 ;

	for ( Loop = 0 ; Loop < 4 ; Loop ++)
	{
		TempValue = IntegerValue / BaseQty ;

			if 	( TempValue > 0) 	
				{
					*ASCII_Buf++ = (unsigned char)TempValue + '0' ;
					ZeroDisable = 0 ;
				}
			else if	( ZeroDisable == 0 ) 
					*ASCII_Buf++ = '0' ;
		IntegerValue = IntegerValue - ( TempValue * BaseQty ) ;
		BaseQty = BaseQty / 10 ;

	}
		*ASCII_Buf++ = (unsigned char)IntegerValue + '0' ;
		*ASCII_Buf = (unsigned char) 0x00 ;
		
}
