// ***********************************************************************
// File :    	ADC_PWM.c
// Purpose : 	ϥ Motor Control PWM Ĳo ADC ഫ
// 				]w SEVTCMP iHഫI
//              Y PTPER ] 1000 , h SEVTCMP Ȥ]bd
// ***********************************************************************


#include 	<timer.h>
#include 	<p30F4011.h>
#include	"C30EVM_LCD.h"
#define		LED7		LATBbits.LATB4 
#define		CTRL_LED7	TRISBbits.TRISB4 

#define		FCY	7372800 * 2
 
void		Timer3_Initial( void ) ;
void		ADC10_Initial( void ) ;
void		uitoa( unsigned char *, unsigned int ) ;
void 		MotPWM_Initial(void) ;
void		Delay_123( void ) ;


union
	{
	unsigned Word ; 
	struct		
		{	
			unsigned AD_DONE : 1 ;
			unsigned : 15 ;
		};
	} Flags ;

unsigned int	ADC_Buf ;
unsigned char	ASCII_Buf[10] ;

//---------------------------------------------------------------------------
// Configuration bits

   _FOSC(CSW_FSCM_OFF & XT_PLL8);   //XT with 4xPLL oscillator, Failsafe clock off
   _FWDT(WDT_OFF);                  //Watchdog timer disabled
   _FBORPOR(PBOR_OFF & MCLR_EN);    //Brown-out reset disabled, MCLR reset enabled
   _FGS(CODE_PROT_OFF);             //Code protect disabled


void _ISR _ADCInterrupt(void)
{
		Flags.AD_DONE = 1 ;
		IFS0bits.ADIF = 0 ;
		ADC_Buf = ADCBUF0 ;
		LED7 = !LED7 ;
}

int	main( void )
{
		ADC10_Initial( ) ;
		OpenLCD( ) ;
		MotPWM_Initial( ) ;
	
		CTRL_LED7 = 0 ;

		Flags.Word = 0 ;
		  putrsLCD("Ex4:ADC Trigger ") ;
		    setcurLCD(0,1) ;
		      putrsLCD("PWM Trig AD=    ") ;

		SEVTCMP = 250 ;

 while (1) 
	{
		while ( Flags.AD_DONE == 0 ) ;
			Flags.AD_DONE = 0 ;
				
				PDC1 = ((long)ADC_Buf * 736 )/512 ;

			setcurLCD(12,1) ;
			putrsLCD("    ") ;
			setcurLCD(12,1) ;
			uitoa( ASCII_Buf , ADC_Buf );
			putsLCD(ASCII_Buf) ;

			Delay_123( ) ;
	}
}

void	Delay_123(void)
{
		int	X ,Y ;
		for ( X = 0 ; X < 30000 ; X ++ )
		Y = Y + 1 ;

}

void ADC10_Initial(void)
{

 	ADPCFG = 0xFFBF;				// TODO : AN6/RB6 is]w Analog , others are Digital;
 	ADCON1 = 0x0066;				// TODO : ]w ADCON1
									// 0bXXXX XXXX XXXX XXXX
									// Auto convert using PWM as trigger source
									// A/D Sample Auto-Start
 	ADCON2 = 0x0000;				// ADCON2 = 0000 0000 0000 0000
									// Don't scan inputs , SMPi = 00 ( Interrupt for each sample/convert )
 	ADCSSL = 0x0000;				// no scan input selected .......
 	ADCON3 = 0x1F3F;				// TAD = 8 Tcy , SAMC = 15 TAD 
	ADCHS =  0x06 ;					// ADCHS = 0b 00000000 00000111

	IEC0bits.ADIE = 1 ;				// Enable AD interrupt
	IPC2bits.ADIP = 7 ;				// Set Priority to 7 	>> highest !!
 
 	ADCON1bits.ADON = 1;			// turn ADC ON
}

void 	MotPWM_Initial(void)
{
		IEC2bits.PWMIE = 0 ;	// Disable PWM Interrupt !!
		IEC2bits.FLTAIE = 0 ;	

		OVDCON = 0xff00 ;		// Active all PWM OUTPUT !!

		TRISE = 0xffc0 ;		
		PTCON = 0x8000 ;		//	TODO : T]w PTCON
								// Configure as 0b1000 0000 0000 0000
								// PWM Time Base Prescale = 1:1
								// PWM Time Base OP in free running Mode 
		PWMCON1 = 0x00ff ;		//	TODO : T]w PWMCON1
								// Configure as 0b0000 0000 1111 1111
								// PWM I/O in complementary Mode and only PWM1L/H as PWM output 
		PWMCON2 = 0x0000 ;		// Configure as 0b0000000000000000 

		DTCON1 = 0x0010 ;		// TODO : Dead Time A ]w 16 Tcy
								// Configure as 0b0000 0000 0001 0000  ;

		FLTACON = 0x0000 ;

		IPC9bits.PWMIP = 6 ;

			PTPER = 736 ;		// ]w PTPER , Ʊo쪺 PWM Wv = 20 Khz
								// 20KHz, PETR= [7372800 * 2 / (20000*1)] -1 = 736
								// PTPER -> PWM Time Base Period Register 

			PDC1 = 512 ;
			PDC2 = 512 ;
			PDC3 = 512 ;		

}

void	uitoa( unsigned char *ASCII_Buf , unsigned int IntegerValue )
{
	
	unsigned int TempValue ;
	unsigned char ZeroDisable ;
	unsigned int  BaseQty ;
	unsigned int  Loop ;

	ZeroDisable = 1 ;
	BaseQty = 10000 ;

	for ( Loop = 0 ; Loop < 4 ; Loop ++)
	{
		TempValue = IntegerValue / BaseQty ;

			if 	( TempValue > 0) 	
				{
					*ASCII_Buf++ = (unsigned char)TempValue + '0' ;
					ZeroDisable = 0 ;
				}
			else if	( ZeroDisable == 0 ) 
					*ASCII_Buf++ = '0' ;
		IntegerValue = IntegerValue - ( TempValue * BaseQty ) ;
		BaseQty = BaseQty / 10 ;

	}
		*ASCII_Buf++ = (unsigned char)IntegerValue + '0' ;
		*ASCII_Buf = (unsigned char) 0x00 ;
		
}
