// ***********************************************************************
// File :    	ADC_PWM.c
// Purpose : 	ϥ Motor Control PWM Ĳo ADC ഫ
// 				]w SEVTCMP iHഫI
//              Y PTPER ] 1000 , h SEVTCMP Ȥ]bd
// ***********************************************************************

#define __dsPIC30F4011_

#include 	<timer.h>
#include 	<p30F4011.h>
#define		LED16		LATFbits.LATF0 
#define		CTRL_LED16	TRISFbits.TRISF0 

#define		FCY	7372800 * 4
 
void		Timer3_Initial( void ) ;
void		ADC10_Initial( void ) ;
void		uitoa( unsigned char *, unsigned int ) ;
void 		MotPWM_Initial(void) ;


union
	{
	unsigned Word ; 
	struct		
		{	
			unsigned AD_DONE : 1 ;
			unsigned : 15 ;
		};
	} Flags ;

unsigned int	ADC_Buf ;
unsigned char	ASCII_Buf[10] ;

//---------------------------------------------------------------------------
// Configuration bits

   _FOSC(CSW_FSCM_OFF & XT_PLL8);   //XT with 4xPLL oscillator, Failsafe clock off
   _FWDT(WDT_OFF);                  //Watchdog timer disabled
   _FBORPOR(PBOR_OFF & MCLR_EN);    //Brown-out reset disabled, MCLR reset enabled
   _FGS(CODE_PROT_OFF);             //Code protect disabled


void _ISR _ADCInterrupt(void)
{
		Flags.AD_DONE = 1 ;
		IFS0bits.ADIF = 0 ;
		ADC_Buf = ADCBUF0 ;
}

int	main( void )
{
		ADC10_Initial( ) ;
		MotPWM_Initial( ) ;
	

		Flags.Word = 0 ;
		SEVTCMP = 500 ;

 while (1) 
	{
		while ( Flags.AD_DONE == 0 ) ;
			Flags.AD_DONE = 0 ;
	}
}

void ADC10_Initial(void)
{

 	ADPCFG = 0xFF7F;				// AN7/RB7 is Analog , others are Digital;
 	ADCON1 = 0x0066;				// 0b0000 0000 0110 0110 
									// Auto convert using PWM as trigger source
									// A/D Sample Auto-Start
 	ADCON2 = 0x0000;				// ADCON2 = 0000 0000 0000 0000
									// Don't scan inputs , SMPi = 00 ( Interrupt for each sample/convert )
 	ADCSSL = 0x0000;				// no scan input selected .......
 	ADCON3 = 0x1F3F;				// TAD = 8 Tcy , SAMC = 15 TAD 
	ADCHS =  0x07 ;					// ADCHS = 0b 00000000 00000111

	IEC0bits.ADIE = 1 ;				// Enable AD interrupt
	IPC2bits.ADIP = 7 ;				// Set Priority to 7 	>> highest !!
 
 	ADCON1bits.ADON = 1;			// turn ADC ON
}

void 	MotPWM_Initial(void)
{
		IEC2bits.PWMIE = 0 ;	// Disable PWM Interrupt !!
		IEC2bits.FLTAIE = 0 ;	

		OVDCON = 0xff00 ;		// Active all PWM OUTPUT !!

		TRISE = 0xffc0 ;		
		PTCON = 0xa002 ;		// Configure as 0b1010 0000 0000 0010 
								// PWM Time Base Prescale = 1:16 
								// PWM Time Base OP in free running Mode 
		PWMCON1 = 0x0077 ;		// Configure as 0b0000000001110111
								// PWM I/O in complementary Mode and only PWM1L/H as PWM output 
		PWMCON2 = 0x0000 ;		// Configure as 0b0000000000000000 

		DTCON1 = 0x010F ;		// 

		FLTACON = 0x0000 ;

		IPC9bits.PWMIP = 6 ;

			PTPER = 511 ;		// PWM Time Base Period Register 

			PDC1 = 200 ;
			PDC2 = 256 ;
			PDC3 = 128 ;		

}

void	uitoa( unsigned char *ASCII_Buf , unsigned int IntegerValue )
{
	
	unsigned int TempValue ;
	unsigned char ZeroDisable ;
	unsigned int  BaseQty ;
	unsigned int  Loop ;

	ZeroDisable = 1 ;
	BaseQty = 10000 ;

	for ( Loop = 0 ; Loop < 4 ; Loop ++)
	{
		TempValue = IntegerValue / BaseQty ;

			if 	( TempValue > 0) 	
				{
					*ASCII_Buf++ = (unsigned char)TempValue + '0' ;
					ZeroDisable = 0 ;
				}
			else if	( ZeroDisable == 0 ) 
					*ASCII_Buf++ = '0' ;
		IntegerValue = IntegerValue - ( TempValue * BaseQty ) ;
		BaseQty = BaseQty / 10 ;

	}
		*ASCII_Buf++ = (unsigned char)IntegerValue + '0' ;
		*ASCII_Buf = (unsigned char) 0x00 ;
		
}
